/**********************************************************************/
/*   By Stefan Pantos. E-Mail: Stefuser@yahoo.com                     */
/*	 Last Modified: 21/07/2000										  */
/**********************************************************************/
/******************************************************************************
*
*    Copyright (C) 2000 Stefan Pantos
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 
* 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
***********************************************************************/
#include <userint.h>
#include "DiffConv.h"
#include "CPIOps.h"

CPIOption CPIOpt;

void saveCPIOptions(panelStruct *panelInfo);

void setCPIOptions(panelStruct *panelInfo)
{
	if (CPIOpt.waveLength>0)
	{
		SetCtrlVal(panelInfo->panelHandle, kCPIOPTS_kWAVELENGTH, CPIOpt.waveLength);
		SetCtrlVal(panelInfo->panelHandle, kCPIOPTS_kWLSYMBOL, CPIOpt.anodeSymbol);
	}
}

void initCPIOptPanel(panelStruct *panelInfo)
{
	setCPIOptions(panelInfo);
	SetCtrlAttribute(panelInfo->panelHandle, kCPIOPTS_kOKBUTTON, ATTR_CALLBACK_DATA, panelInfo);
	SetCtrlAttribute(panelInfo->panelHandle, kCPIOPTS_kCANCELBUTTON, ATTR_CALLBACK_DATA, panelInfo);
	SetPanelAttribute(panelInfo->panelHandle, ATTR_CALLBACK_DATA, panelInfo);
}

int CVICALLBACK okCPI (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int options = *((int *)((panelStruct *)callbackData)->otherData); 
	switch (event)
		{
		case EVENT_COMMIT:
			saveCPIOptions((panelStruct *)callbackData);         
			options = removeOption(options, CPIOptions);  
			windowToClose((panelStruct *)callbackData);
			displayOptionPanels(options); 
			break;
		}
	return 0;			 
}

int CVICALLBACK cancelCPI (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			RemovePopup(((panelStruct *)callbackData)->panelHandle);
			DisplayPanel(((panelStruct *)callbackData)->parentPanelHandle);
			windowToClose((panelStruct *)callbackData);	
			break;
		}
	return 0;
}

int CVICALLBACK CPIPanelMethod (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
			RemovePopup(((panelStruct *)callbackData)->panelHandle);
			DisplayPanel(((panelStruct *)callbackData)->parentPanelHandle);
			windowToClose((panelStruct *) callbackData);
			break;
		}
	return 0;
}

void saveCPIOptions(panelStruct *panelInfo)
{
	GetCtrlVal(panelInfo->panelHandle, kCPIOPTS_kWAVELENGTH, &CPIOpt.waveLength);
	GetCtrlVal(panelInfo->panelHandle, kCPIOPTS_kWLSYMBOL, CPIOpt.anodeSymbol);
}
