/**********************************************************************/
/*   By Stefan Pantos. E-Mail: Stefuser@yahoo.com                     */
/*	 Last Modified: 21/07/2000										  */
/**********************************************************************/
/******************************************************************************
*
*    Copyright (C) 2000 Stefan Pantos
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 
* 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
***********************************************************************/
#include "DiffConv.h"
#include <userint.h>
#include "ConstantStepOptPanel.h"
#include "myWindowUtils.h"

ConstantStepOptions constStepOpts;

void setOptions(panelStruct *panelInfo)
{
	if (constStepOpts.stepValue>0)
	{
		SetCtrlVal(panelInfo->panelHandle, kCONSPANEL_kSTEPVALUE, constStepOpts.stepValue);
	}
	if (constStepOpts.conversionMethod!=0)
	{
		SetCtrlVal(panelInfo->panelHandle, kCONSPANEL_kSPLINECURVECONST, 0); 
		SetCtrlVal(panelInfo->panelHandle, kCONSPANEL_kLINEARCONST, 0);
		switch (constStepOpts.conversionMethod)
		{
 			case kSPLINE:
 				SetCtrlVal(panelInfo->panelHandle, kCONSPANEL_kSPLINECURVECONST, 1); 
 			break;
 			case kLINEAR:
 			default:
 				SetCtrlVal(panelInfo->panelHandle, kCONSPANEL_kLINEARCONST, 1);
 			break;
		}		
	}
}

void saveConstOptions(panelStruct *panelInfo)
{
	int methodOpRebinning=0, methodOpLinearConst = 0;
						 
	GetCtrlVal(panelInfo->panelHandle, kCONSPANEL_kSTEPVALUE, &(constStepOpts.stepValue));
	GetCtrlVal(panelInfo->panelHandle, kCONSPANEL_kLINEARCONST, &methodOpLinearConst);
	GetCtrlVal(panelInfo->panelHandle, kCONSPANEL_kOUTPUTASFLOATS, &constStepOpts.outputFloatingCounts);
	if (methodOpLinearConst == 1)
	{
		constStepOpts.conversionMethod=kLINEAR;	
	}
	else 
	{
		constStepOpts.conversionMethod = kSPLINE;
	}
}																					

void initConstStepOpsPanel(panelStruct *panelInfo)
{
	setOptions(panelInfo);
	SetCtrlAttribute(panelInfo->panelHandle, kCONSPANEL_kOKBUTTON, ATTR_CALLBACK_DATA, panelInfo);
	SetCtrlAttribute(panelInfo->panelHandle, kCONSPANEL_kCANCELBUTTON, ATTR_CALLBACK_DATA, panelInfo);
	SetPanelAttribute(panelInfo->panelHandle, ATTR_CALLBACK_DATA, panelInfo);
}

int CVICALLBACK cancelButtonConstPanel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int ctrlVal=0;
	
	switch (event)
		{
		case EVENT_COMMIT:
//				SetPanelAttribute(((panelStruct *)callbackData)->parentPanelHandle, ATTR_CALLBACK_DATA, callbackData);
				RemovePopup(((panelStruct *)callbackData)->panelHandle);
				DisplayPanel(((panelStruct *)callbackData)->parentPanelHandle);
				windowToClose((panelStruct *) callbackData);
			break;
		}
	return 0;
}

int CVICALLBACK linearConstOpPanel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int ctrlVal=0;
	
	switch (event)
		{
		case EVENT_COMMIT:
				GetCtrlVal(panel, kCONSPANEL_kLINEARCONST, &ctrlVal);
				if (ctrlVal==1)
				{
					SetCtrlVal(panel, kCONSPANEL_kSPLINECURVECONST, !ctrlVal);
				}
				else
				{
					SetCtrlVal(panel, kCONSPANEL_kLINEARCONST, !ctrlVal);
				}
			break;
		}
	return 0;
}

int CVICALLBACK okButtonConstPanel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int options = *((int *)((panelStruct *)callbackData)->otherData);
	
	switch (event)
		{
		case EVENT_COMMIT:
				saveConstOptions((panelStruct *)callbackData);
				options = removeOption(options, constantStepOptions);
				RemovePopup(((panelStruct *)callbackData)->panelHandle);
				windowToClose((panelStruct *) callbackData);
				displayOptionPanels(options);
			break;
		}
	return 0;
}

int CVICALLBACK constepOpPanel (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
			RemovePopup(((panelStruct *)callbackData)->panelHandle);
			DisplayPanel(((panelStruct *)callbackData)->parentPanelHandle);
			windowToClose((panelStruct *) callbackData);
			break;
		}
	return 0;
}

int CVICALLBACK splineConstOpPanel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int ctrlVal = 0;
	switch (event)
		{
		case EVENT_COMMIT:
				GetCtrlVal(panel, kCONSPANEL_kSPLINECURVECONST, &ctrlVal);
				if (ctrlVal==1)
				{
					SetCtrlVal(panel, kCONSPANEL_kLINEARCONST, !ctrlVal);
				}
				else
				{
					SetCtrlVal(panel, kCONSPANEL_kSPLINECURVECONST, !ctrlVal);
				}
			break;
		}
	return 0;
}
