#ifndef __CONVESION_H__
#define __CONVESION_H__

/************Conversion types****************/
#define kNOCONVERSION   0
#define kTWOTHETALINEAR 1
#define kTWOTHETASPLINE 2
#define kNULLCONVERSION 3

/**********Other option flags****************/
#define kROUNDTOINT   	1 << 0
#define kCONSTANTSTEP 	1 << 1
#define kLIMITRANGE   	1 << 2
#define kFLOATINGCOUNTS 1 << 3

/***********File types***************/
#define kDONTKNOW -1
#define kTEXT 0
#define kXFIT 1
#define kCPI  2
#define kLHMP 3
#define kGUFI 4
#define kCHN  5

typedef struct convertParamBlock
{
	char *inputFileName;
	char *outputFileName;
	int inputFileType;
	short conversionType;
	short conversionOtherOptions;
	int fileOutputType;
	short addExtension;
	int progressPanelHandle;
	int parentPanelHandle;
}convertParamBlock;

//File header of MCA file
typedef struct MCAFileHeader
{
	short int fileType;		//This is an id for the file type. For this program it should always be -1.
	short int MCANum;		//1-4 is valid.
	short int SegmentNum;	//Segment Number
	char startTime[2];		//Start Time
	long realtime;			//20ms Ticks
	long livetime;			//20ms Ticks
	char acqTime[12];		//start date, start year, start month, start mins.
	short int chan_offset;	//The number of the chanel which the file started from.
	short int num_chans;    //This is the number of channels which have been stored in the file.
}MCAFileHeader;

typedef struct GUFIHeader
{
	short measureMode;
	float startAng;
	float stepAng;
	short numPoints;
	float measureTime;
	float timePerStep;
	unsigned short geometry;
	char measureDevice[41];
	float minAngle;
	float maxAngle;
	char anodeSymbol[3];
	float ka1WL;
	float ka2WL;
	char genType[41];
	float genV;
	float genCurr;
	float gonioRad;
	unsigned short divSlit;
	float divWidth;
	float receivWidth;
	float normalAngle;
	char detectorType[41];
	float deadTime;
	char monochromaterType[41];
	float dValue;
	char sampleID[31];
	char date[11];
	char time[9];
	char sampleFormula[31];
	char sameleOrigin[31];
	char temp[31];
	char grainSize[31];
	char operator[31];
	char numOfICDD_JCPDS_Card[31];
	char numOfICDD_JCPDS_grant[31];
	char remarks[128];
}GUFIHeader;

void convertFiles(int parentPanel);
#endif
