#ifndef __DiffConvTYPES_H__
#define __DiffConvTYPES_H__

#define kMAXNUMOFPOINTS 512 //This is the maximum number of data points which can be used to calibrate the program. 

/**option panel flag masks**/
#define constantStepOptions 1 << 0
#define rangeOption			1 << 1
#define convertOption		1 << 2
#define CPIOptions          1 << 3

/**********File type strings**************/
#define kTXTFILESTRING "Tab Delimited Text File"
#define kXFITFILESTRING "XFIT File"
#define kCPIFILESRING "CPI File"
#define kLHPMFILESTRING "LHPM File"
#define kGUFIFILESTRING "Binary GUFI File"

//*********************Structures**********************************
//Panel structure this is used so that global varibales for all the panels aren't needed.
//The panel structures are past to the windows callbackdata attribute.
typedef struct panelStruct
{
	int panelHandle;	  //The panels own handle.
	int parentPanelHandle;//The handle to the panels parent panel.
	void * otherData;	  //A pointer to some other data which the panel my need.
}panelStruct;

// This is a structure for the data points entered in for calibration
typedef struct xyPoints
{
	double tThetaValue, channelNum;//The 2-theta vale and it's corasponding channel number of a peak
	char deleted;				   //A flag to say if it is storing usfull information or not.
}xyPoints;
//******************************************************************

/***********Prototypes***********************************************/
void SetCalibrationMessages(void);
void displayOptionPanels(int optionPanelFlags);
int strCmp(char *string1, char *string2);
double sqr(double num) ;
/********************************************************************/

#endif
