#ifndef __OPTIONS_H__
#define __OPTIONS_H__
#include <formatio.h>
#include <ansi_c.h>

//The calibration values for the convertion of channel numbers to 2-theta
typedef struct Calibration
{  
	int version;		//For later uses when there are more than one version of file
	//These are the constants for the convertion formula. at the moment the formula is
	//y=Cx+K but should be arcsin(x/C)+K=y I think
	double K; 	//The 2-theta angle of the first channel on the detector
	double C;  //The 2-theta angle for each of the channels
	int numOfCalibPoints;
}Calibration;

typedef struct calPoint
{
	double xPoint, yPoint, yDashed;
}calPoint;

extern char projectDir[300]; //The directory where the program is stored.
extern calPoint *calPoints;
extern Calibration header;
int saveOptionsFile(char fileName[], int replaceNoOption);  //Saves the value of the Calibration variables into the option file pointed to by the file name parameter.
void readOptionsFile(char fileName[]);    //read the calibreation values from on option file with the path which is passed into fileName
void getCalibration(void); 			//This read the defeult option file and creates one if one doesn't exist.
long readLine(int fileHandle, char *string, int maxLength);
#endif
