/**********************************************************************/
/*   By Stefan Pantos. E-Mail: Stefuser@yahoo.com                     */
/*	 Last Modified: 21/07/2000										  */
/**********************************************************************/
/******************************************************************************
*
*    Copyright (C) 2000 Stefan Pantos
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 
* 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
***********************************************************************/
#include <userint.h>
#include "DiffConv.h"
#include "RangeOptPanel.h"
#include "myWindowUtils.h"

RangeOptions theRangeOptions;

void setControls(panelStruct *panelInfo)
{
	if (theRangeOptions.startValue<theRangeOptions.endValue)
	{
		SetCtrlVal(panelInfo->panelHandle, kRANGEOPT_kMINRANGE, theRangeOptions.startValue);
		SetCtrlVal(panelInfo->panelHandle, kRANGEOPT_kMAXRANGE, theRangeOptions.endValue);
	}
}

int saveRangeOptions(panelStruct *panelInfo)
{
	double min, max;
	
	GetCtrlVal(panelInfo->panelHandle, kRANGEOPT_kMINRANGE, &min);
	GetCtrlVal(panelInfo->panelHandle, kRANGEOPT_kMAXRANGE, &max);
	if (min>max)
	{
		MessagePopup("Not Possible", "Max 2-theta Value must be larger\nthen Min 2-Theta Value.");	
		return 0;
	}
	GetCtrlVal(panelInfo->panelHandle, kRANGEOPT_kMINRANGE, &theRangeOptions.startValue);
	GetCtrlVal(panelInfo->panelHandle, kRANGEOPT_kMAXRANGE, &theRangeOptions.endValue);
	return 1;
}

void initRangeOpsPanel(panelStruct *panelInfo)
{   
	setControls(panelInfo);
	SetCtrlAttribute(panelInfo->panelHandle, kRANGEOPT_kOKBUTTON, ATTR_CALLBACK_DATA, panelInfo);
	SetCtrlAttribute(panelInfo->panelHandle, kRANGEOPT_kCANCELBUTTON, ATTR_CALLBACK_DATA, panelInfo);
	SetPanelAttribute(panelInfo->panelHandle, ATTR_CALLBACK_DATA, panelInfo);
}


int CVICALLBACK limitOptionPanel (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
			RemovePopup(((panelStruct *)callbackData)->panelHandle);
			DisplayPanel(((panelStruct *)callbackData)->parentPanelHandle);
			windowToClose((panelStruct *) callbackData);
			break;
		}
	return 0;
}

int CVICALLBACK okLimitButton (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int options = *((int *)((panelStruct *)callbackData)->otherData);
	
	switch (event)
		{
		case EVENT_COMMIT:
			if (saveRangeOptions((panelStruct *)callbackData))
			{
				RemovePopup(((panelStruct *)callbackData)->panelHandle);
				windowToClose((panelStruct *)callbackData);
				options = removeOption(options, rangeOption);
				displayOptionPanels(options);
			}
			break;
		}
	return 0;
}

int CVICALLBACK cancelLimitButton (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			RemovePopup(((panelStruct *)callbackData)->panelHandle);
			DisplayPanel(((panelStruct *)callbackData)->parentPanelHandle);
			windowToClose((panelStruct *) callbackData);
			break;
		}
	return 0;
}

