/******************************************************************************
*
*    Copyright (C) 2000 Stefan Pantos
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 
* 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
***********************************************************************/
#include <utility.h>
#include <userint.h>
#include <ansi_c.h>
#include "myWindowUtils.h"

void windowToClose(panelStruct * windowsPanelStruct)
{
	if (windowsPanelStruct!=NULL) //Check to see if it was a panel it just returned from.
	{ //If it was then...
		DisableBreakOnLibraryErrors();
		if (DiscardPanel(windowsPanelStruct->panelHandle)>=0) //it remove the panel which it has just come from, from memory and check that it wsa removed OK.
		{//If it was then...
			if (windowsPanelStruct->otherData!=NULL)
			{		  
		//		free(windowsPanelStruct->otherData);
			}
			free(windowsPanelStruct); //It remove the panel structure fron memory.
		}
		EnableBreakOnLibraryErrors();
	}
}

int removeOption(int optionString, int optionToRemove)
{
	return optionString & ~optionToRemove;
}

panelStruct* createPanelStruct(int panelHandle, int parentPanel, void *otherData)  
{
	panelStruct *tempStruct = NULL;
	
	tempStruct = malloc(sizeof(panelStruct));
	
	tempStruct->panelHandle = panelHandle;
	tempStruct->parentPanelHandle = parentPanel;
	tempStruct->otherData = otherData; 
	return tempStruct;
}
